/**
 * @file usb_device_task.h,v
 *
 * 쌠 (c) 2004 Atmel.
 *
 * 쌠ʒmɂĂlicense.txţقǂ݂B
 *
 * @brief ̧قUSBuƗp̊֐錾܂݂܂B
 *
 * @version 1.2 at90usb128-otg-dual_role-toggle-1_0_0 $Id: usb_device_task.h,v 1.2 2007/02/13 10:17:53 arobert Exp $
 *
 * @todo
 * @bug
 */

#ifndef _USB_DEVICE_TASK_H_
#define _USB_DEVICE_TASK_H_

//! @defgroup usb_device_task USBuƕ
//! @{

//_____ ݸٰ _______________________________________________________________

//_____ ϸ ___________________________________________________________________

//_____ 錾 __________________________________________________________________

//!
//! @brief Definitions of B-uԂ̒`
//!
#define B_IDLE				0
#define B_SRP_INIT			1
#define B_PERIPHERAL		2
#define B_WAIT_ACON			3
#define B_HOST				4
#define B_END_HNP_SUSPEND	5

//!
//! @brief OTG B-uSRPKԂ܂͎
//!
extern U8 otg_device_sessions;
extern U8 otg_b_device_state;
extern U8 sof_seen_in_session;

  //!  ݂̍ƂSRP̌ʂ?
#define Start_session_with_srp()			(otg_device_sessions |= 0x01)
#define End_session_with_srp()				(otg_device_sessions &= ~0x01)
#define Is_session_started_with_srp()		(((otg_device_sessions&0x01) != 0) ? TRUE : FALSE)

  //! SRPĉ҂
#define Srp_sent_and_waiting_answer()		(otg_device_sessions |= 0x02)
#define Ack_srp_sent_and_answer()			(otg_device_sessions &= ~0x02)
#define Is_srp_sent_and_waiting_answer()	(((otg_device_sessions&0x02) != 0) ? TRUE : FALSE)

  //! Tb_Srpv틖? Tb_Srp_Failo߂̏ꍇɌvɂĉ܂B
//! Tb_Srp_Fail5`6b̊ԂłȂ΂Ȃ܂B2msɎs銄荞ٰ݂ƂŁA̒l2500(5.2bgp)ɂȂ܂B
#define TB_SRP_FAIL_MIN						0x0A28
extern U16 otg_tb_srp_cpt;
#define Init_tb_srp_counter()				(otg_tb_srp_cpt = 0)
#define Is_tb_srp_counter_overflow()		((otg_tb_srp_cpt > TB_SRP_FAIL_MIN) ? TRUE : FALSE)

//!
//! @brief ̊֐USBu܂B
//!
//! ̊֐USBUSB荞݂܂BړI͓`ԊǗ
//! ɓK؂USBۂ𑗂邽߂USBڑoƂłB
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_device_task_init (void);

//!
//! @brief ̊֐USBu܂B
//!
//! ̊֐USBUSB荞݂܂BړI͖ړI͓`
//! ԊǗɓK؂USBۂ𑗂邽߂USBڑoƂłB
//! xVBUSڑVBUSω荞݂܂VBUS Highق̂ǂ炩ɂČo
//! ƁAuJn֐s܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_start_device (void);

//! @brief USBuǗ̓(_)
//!
//! ̊֐USBǗ̓(_)łBeUSBۂ͓K؂ȊJn邽߂ɂ
//! Œׂ܂B萧߲Ăō\ݒ(Setup)vNꍇAusb_
//! standard_request.çٓusb_process_request()֐Ă΂܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void usb_device_task (void);

//! @}

#endif /* _USB_DEVICE_TASK_H_ */
