//! @file pll_drv.h
//! pll_drv.h,v
//!
//! 쌠 (c) 2006 Atmel.
//!
//! 쌠mɂĂlicense.txţقǂłB
//!
//! @brief ̧قUSB PLLɊւϸۂƒ`܂݂܂B
//!
//! @version 1.7 at90usb128-otg-dual_role-toggle-1_0_0
//!
//! @todo

#ifndef PLL_DRV_H
#define PLL_DRV_H

//_____ ݸٰ ____________________________________________________

//! @defgroup PLL PLLײޕ
//! PLL
//! @{

//_____ ϸ ________________________________________________________

	//! @defgroup PLL_macros PLLϸ
	//! ̊֐PLL̐܂B
	//! @{
#define PLLx24 		( (0<<PLLP2) | (0<<PLLP1) | (0<<PLLP0) )
#define PLLx12 		( (0<<PLLP2) | (0<<PLLP1) | (1<<PLLP0) )
#define PLLx08 		( (0<<PLLP2) | (1<<PLLP1) | (0<<PLLP0) )
#define PLLx06 		( (0<<PLLP2) | (1<<PLLP1) | (1<<PLLP0) )
#define PLLx04 		( (1<<PLLP2) | (0<<PLLP1) | (0<<PLLP0) )
#define PLLx03 		( (1<<PLLP2) | (0<<PLLP1) | (1<<PLLP0) )
#define PLLx04_8	( (1<<PLLP2) | (1<<PLLP1) | (0<<PLLP0) )
#define PLLx02		( (1<<PLLP2) | (1<<PLLP1) | (1<<PLLP0) )

		//! @brief 48MHzPLLnBCPUgɊւāAۯWƂUSB PLLn
		//! BۯẂ~3,~4,~6,~8,~12,~24ɂł܂B
#define Start_pll(clockfactor)		(PLLCSR = ( clockfactor | (1<<PLLE)  ))

#define Is_pll_ready()				(PLLCSR & (1<<PLOCK) )				//!< PLLŒ艻1Ԃ܂B
#define Wait_pll_ready()			while (!(PLLCSR & (1<<PLOCK)))		//!< PLLŒ艻ޯČAŒ艻ݒ(1)܂őҋ@
#define Stop_pll()					(PLLCSR  &= (~(1<<PLLE)) )			//!< PLL~

		// FOSC`ɊւĎW`ԂPLLn
#if   (FOSC==2000)
  #define Pll_start_auto()			Start_pll(PLLx24)
#elif (FOSC==4000)
  #define Pll_start_auto()			Start_pll(PLLx12)
#elif (FOSC==6000)
  #define Pll_start_auto()			Start_pll(PLLx08)
#elif (FOSC==8000)
  #define Pll_start_auto()			Start_pll(PLLx06)
#elif (FOSC==12000)
  #define Pll_start_auto()			Start_pll(PLLx04)
#elif (FOSC==16000)
  #define Pll_start_auto()			Start_pll(PLLx03)
#elif (FOSC==20000)
  #define Pll_start_auto()			Start_pll(PLLx04_8)
#elif (FOSC==24000)
  #define Pll_start_auto()			Start_pll(PLLx02)
#else
  #error "FOSC should be defined in config.h"
#endif

	//! @}
//! @}
#endif // PLL_DRV_H
