//! @file usb_standard_request.h,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief USBu(ڑF)vͯ ̧
//!
//! ̧ق͕W(ڑF)(USBdl9͎Q)ɑΉUSB߲0
//! ٰ݂܂݂܂B
//! ̧ق͔WvǗɑ΂usb_specific_request.çقٰ݂Ăяo
//! ܂B
//! (ڑF)Ұ(Lqq\)usb_descriptors.çٓɊ܂܂܂B
//!
//! @version 1.5 at90usb128-otg-dual_role-toggle-1_0_0 $Id: usb_standard_request.h,v 1.5 2007/02/13 10:18:44 arobert Exp $
//!
//! @todo
//! @bug

#ifndef _USB_ENUM_H_
#define _USB_ENUM_H_

//_____ ݸٰ _______________________________________________________________

#include "modules/usb/usb_task.h"
#include "usb_descriptors.h"

//_____ ϸ ___________________________________________________________________

//_____ W` ______________________________________________________________

//! @defgroup std_request USBuWv
//! @{

	// u
#define ATTACHED						0
#define POWERED							1
#define DEFAULT							2
#define ADDRESSED						3
#define CONFIGURED						4
#define SUSPENDED						5

#define USB_CONFIG_ATTRIBUTES_RESERVED	0x80
#define USB_CONFIG_BUSPOWERED			(USB_CONFIG_ATTRIBUTES_RESERVED | 0x00)
#define USB_CONFIG_SELFPOWERED			(USB_CONFIG_ATTRIBUTES_RESERVED | 0x40)
#define USB_CONFIG_REMOTEWAKEUP			(USB_CONFIG_ATTRIBUTES_RESERVED | 0x20)

#define USB_REMOTE_WAKEUP				1
#define OTG_B_HNP_ENABLE				3
#define OTG_A_HNP_SUPPORT				4
#define OTG_A_ALT_HNP_SUPPORT			5

//_____ 錾 __________________________________________________________________

	//! @brief uνĂƐڑĐ(ڑF)ꂽɐ^Ԃ܂B
	//! uʉp͉ꂩ̐\vsOɎׂłB
#define Is_device_enumerated()			((usb_configuration_nb!=0) ? TRUE : FALSE)
#define Is_device_not_enumerated()		((usb_configuration_nb!=0) ? FALSE : TRUE)

	//! @brief SetFeatureνĂɂđꂽOTG@\Ԃ܂B
	//! @\܂(޽ ؾĂ܂͍ƏIł̂)B
#define Is_host_supports_hnp()			(((otg_features_supported&OTG_A_HNP_SUPPORT) != 0) ? TRUE : FALSE)
#define Is_host_requested_hnp()			(((otg_features_supported&OTG_B_HNP_ENABLE) != 0) ? TRUE : FALSE)
#define Clear_otg_features_from_host()	(otg_features_supported = 0)

//! @brief ̊֐͊萧߲ĂɑꂽSETUPvǂœK؂Ȋ֐
//! т܂Busb_read_request֐̔oAu͎̗v̊Ǘ
//! ܂B
//!
//! Mvx܂USBWvłȂꍇA֐usb_specific_request
//! ̓Ǝ֐Ăяo܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//! @note	xv̈ꗗ
//! GET_DESCRIPTOR
//! GET_CONFIGURATION
//! SET_ADDRESS
//! SET_CONFIGURATION
//! CLEAR_FEATURE
//! SET_FEATURE
//! GET_STATUS
//!
void usb_process_request (void);

extern U8 usb_configuration_nb;

extern U8 otg_device_nb_hnp_retry;

//! @}

#endif // _USB_ENUM_H_
